﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Grid;
using Syncfusion.Pdf.Parsing;
using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace WebApplication8
{
    public partial class _Default : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }
        protected void Button1_Click(object sender, EventArgs e)
        {
            //Get the document file path.
            string file = GetFilePath("Barcode.pdf");
            var byteArray = GetBytesFromFile(file);

            //Load the existing PDF docuemnt.
            PdfLoadedDocument loadedDocument = new PdfLoadedDocument(byteArray, true);

            //Disable the incremental update.
            loadedDocument.FileStructure.IncrementalUpdate = false;

            //Set the compression level to best
            loadedDocument.Compression = PdfCompressionLevel.Best;

            //Add new page to the existing PDF document.
            PdfPageBase page = loadedDocument.Pages.Add();

            //Create PDF graphics for the page.
            PdfGraphics graphics = page.Graphics;

            //Set the standard font.
            PdfFont font = new PdfStandardFont(PdfFontFamily.Helvetica, 20);

            //Draw the text.
            graphics.DrawString("Hello World!!!", font, PdfBrushes.Black, new PointF(0, 0));

            //Get the image file path
            PdfImage image = PdfImage.FromFile(GetFilePath("Autumn Leaves.jpg"));

            //Draw the image
            graphics.DrawImage(image, 0, 100);

            //Create a new compression option.
            PdfCompressionOptions options = new PdfCompressionOptions();

            //Enable the compress image.
            options.CompressImages = true;

            //Set the image quality.
            options.ImageQuality = 50;

            //Assign the compression option to the document
            loadedDocument.CompressionOptions = options;

            //Save the document
            loadedDocument.Save("Output.pdf", HttpContext.Current.Response, HttpReadType.Open);

            //Close the document
            loadedDocument.Close(true);
        }
        public byte[] GetBytesFromFile(string fullFilePath)
        {
            FileStream fs = File.OpenRead(fullFilePath);
            try
            {
                byte[] bytes = new byte[fs.Length];
                fs.Read(bytes, 0, Convert.ToInt32(fs.Length));
                fs.Close();
                return bytes;
            }
            finally
            {
                fs.Close();
            }
        }
        public string GetFilePath(string path)
        {
            string _dataPath = GetCommonFolder(new DirectoryInfo(HttpContext.Current.Request.PhysicalApplicationPath));
            _dataPath += @"\" + path;
            return _dataPath;
        }
        static string GetCommonFolder(DirectoryInfo dtInfo)
        {
            var _folderNames = dtInfo.GetDirectories("Data");
            if (_folderNames.Length > 0)
            {
                return _folderNames[0].FullName;
            }

            return dtInfo.Parent != null ? GetCommonFolder(dtInfo.Parent) : string.Empty;
        }
    }
}